//***************************************************************************

// Copyright (C) 2008 Realmac Software Ltd
// 
// Permission is hereby granted, free of charge, to any person obtaining
// a copy of this software and associated documentation files (the
// "Software"), to deal in the Software without restriction, including
// without limitation the rights to use, copy, modify, merge, publish,
// distribute, sublicense, and/or sell copies of the Software, and to
// permit persons to whom the Software is furnished to do so, subject
// to the following conditions:
// 
// The above copyright notice and this permission notice shall be
// included in all copies or substantial portions of the Software.
// 
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
// EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
// MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
// IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR
// ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF
// CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION
// WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

//***************************************************************************

#import <QuartzCore/CoreAnimation.h>

/* Layer attributes (yeah, we could interpolate these, but this is faster):
 * operationImageCellSize	NSValue<size>
 * operationImageCount		NSNumber<int>
 * selectedOperationImage	NSNumber<int>
 * highlightedThemeImage	NSNumber<int>
 
 * Sublayer attributes:
 * operationImageIndex		NSNumber<int> */

extern NSString *operationImageCellSize;
extern NSString *operationImageCount;
extern NSString *highlightedOperationImage;
extern NSString *operationImageIndex;

@interface RMActivityLayout : NSObject
{
	CATransform3D leftTransform, rightTransform;
	float zDistance, zCenterPosition, zSidePosition;
	float sideSpacingFactor, rowScaleFactor;
}
+ (id)layoutManager;

- (float)positionOfHighlightedOperationImageInLayer:(CALayer *)layer;

- (CFArrayRef)operationImageIndicesOfLayer:(CALayer *)l inRect:(CGRect)r;

@end

//***************************************************************************
