//
//  RWImageIO.h
//  RWPluginUtilities
//
//  Created by Simon Taylor on 19/01/2006.
//  Copyright (c) 2006 Realmac Software. All rights reserved.
//
//  THIS IS A RAPIDWEAVER INTERNAL HEADER FILE AND THE INTERFACES
//  DESCRIBED HERE COULD CHANGE WITHOUT NOTICE 
//

#import <Cocoa/Cocoa.h>


@interface RWImageIO : NSObject

+ (BOOL)available;

/// Unlike most other methods, this method returned a CGImageRef that is _not_ autoreleased!  You are responsible for release the image with CFRelease() or CGImageRelease().
+ (CGImageRef)imageFromFile:(NSString*)path;

+ (CGImageRef)thumbnailFromFile:(NSString*)path size:(NSInteger)size;
+ (NSDictionary*)propertiesFromFile:(NSString*)path;

+ (NSImage*)imageFromCGImage:(CGImageRef)image;

+ (BOOL)writeImage:(NSImage*)image to:(NSString*)path as:(NSString*)format;

@end
