//
//  RWLink.h
//  RWPluginUtilities
//
//  Created by Simon Taylor on 20/02/2005.
//  Copyright (c) 2005 Realmac Software. All rights reserved.
//
//  THIS IS A RAPIDWEAVER INTERNAL HEADER FILE AND THE INTERFACES
//  DESCRIBED HERE COULD CHANGE WITHOUT NOTICE 
//

#import <Cocoa/Cocoa.h>


@interface RWLink : NSObject
{
	NSString* _name;

	NSMutableDictionary* _attributes;

	BOOL _internal;
	NSInteger _asset;
	NSString* _subpageID;

	// This ivar is for backwards compatibility only: it doesn't seem to be used anywhere, but is saved/loaded
	NSString* _anchor;
}

enum {
	kRWLinkNotAnAsset = 0,
	kRWLinkPageAsset = 1,
	kRWLinkSiteAsset = 2
};

@property (copy) NSString* title;
@property (copy) NSString* rel;
@property (copy) NSString* href;
@property (copy) NSString* target;
@property BOOL internal;
@property NSInteger asset;
@property (copy) NSString* subpageID;

@property (retain) NSMutableDictionary* attributes;

- (id)initWithHREF:(NSString*)link internal:(BOOL)internal;

- (NSString*)name;
- (void)setName:(NSString*)name;
- (NSString*)target;
- (void)setTarget:(NSString*)target;


/// The -setHREF: method is for backwards compatibility only (you should be using -setHref: instead)
- (void)setHREF:(NSString*)href;

// For backwards compatibility only
- (NSString*)anchor;
- (void)setAnchor:(NSString*)anchor;

@end
